VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "DirLNode"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'
'A Class used internally by the DirLister Class.
'
Public Enum DirLNodeStates
    dlnNew = 0
    dlnPathValid
    dlnPathEmpty
End Enum
#If False Then
Dim dlnNew, dlnPathValid, dlnPathEmpty
#End If

Public Parent As DirLNode
Public Path As String
Public State As DirLNodeStates
Public SubNodes As Collection

Public Sub HoldSubDir(ByVal Directory As DirLNode)
    If SubNodes Is Nothing Then Set SubNodes = New Collection
    SubNodes.Add Directory
End Sub

Public Function RetrieveNextSubDir() As DirLNode
    Set RetrieveNextSubDir = SubNodes(1)
    SubNodes.Remove 1
    If SubNodes.Count < 1 Then Set SubNodes = Nothing
End Function

Public Property Get HasSubs() As Boolean
    If Not SubNodes Is Nothing Then
        HasSubs = SubNodes.Count > 0
    End If
End Property
